/****************************************************************************************************
*                               		KLASS Graaf2
*									Klassi Graaf alamklass
*				Lisatud mned  graafi lbimisega (mda kaari) seotud isendimeetodid:
*				  * saavutatavaid 		(tippude arv, kuhu saab antud tipust juda)
*                 * onPuu				(puustruktuuri kontroll)
*				  * lbida_sgavuti 	[pik, lk 108]
*					otsida_suvatee 		(he mingi tee hest tipust teise otsimine)
*				  * otsida_kik_teed	(kigi teede hest tipust teise otsimine)
*				  * lbida_Dijkstra 	Dijkstra algoritm [pik, ptk 6.2]
*					lbida_Bellman_Ford Bellman-Fordi algoritm [pik, ptk 6.2]
*	
*					Autorid: lli pilane -- viimistles trniga * mrgitud meetodid 
*                            Jri Kiho    -- kik muu
*								 
*		
*								--- Kitlemine ksurealt (cmd) ---
*		Eeldus: jooksvas kaustas on failid Graaf2.java (see fail, ANSI vi utf-8 kodeeringus),   
*				klassid TeeInfo ja Kahendkuhi ning pakett ee_ut_kiho_aa.zip
*				samuti testimisel kasutatavad graafide failid (nt graafTeed.txt, graafTeedSuur.txt) 
*                           
*     				Kompileerimine:																		
*						Kaustatee>javac -cp .\;ee_ut_kiho_aa.zip Graaf2.java
*							vi
*						Kaustatee>javac -encoding utf8 -cp .\;ee_ut_kiho_aa.zip Graaf2.java
*					Kivitamine:																		
*						Kaustatee>java  -cp .\;ee_ut_kiho_aa.zip Graaf2
*****************************************************************************************************/

import ee.ut.kiho.aa.graaf.*;
import java.util.Vector;

public class Graaf2 extends Graaf{
	
	public Graaf2(Graaf g) {// konstruktor Graaf -> Graaf2
		super(g.toString()); 
	}

	public int saavutatavaid(Tipp t){ ////////////////////////// Etd GTE_1-0 
	// Antud: selle graafi tipp t
	// Tulemus: tagastatakse nende tippude arv, mis on saavutatavad
	//        	antud tipust lhtuvalt (incl tipp t);
	//        	tippudele seatakse vlju "lipp"
	// Eeldus: (veel saavutamata) tippudel puudub vli "lipp" 
		t.seadaVli("lipp", ""); // seada tipule t vli "lipp", thisne   
        // tipule t on seatud vli lbituse mrgiks (vlja vrtus pole oluline)		
		int arv = 1; // tipp t ise
// ...........................
		return arv; 
	}//saavutatavaid
	
	public Tipp onPuu() { ////////////////////////// Etd GTE_1-1
	// ..................
	// Tulemus: tagastatakse tipp t, kui see graaf on puu juurega tipus t
	//                       null, kui see graaf ei ole puustruktuuriga 			
	// ..................

		return null; // liba
	}//onPuu

	public  void lbida_sgavuti(Tipp t){ ////////////////////////// GTE_2-0  
	// Antud: selle graafi tipp t
	// Tulemus: igale tipust t saavutatavale tipule pandud vli "eellane" --
	//			      selle tipu number, kust tippu t (mda hte kaart) tuldi
		t.seadaVli("visatud", ""); // tipule t panna lipp "visatud"	
// ...........................
	}// lbida_sgavuti
	
	public  TeeInfo otsida_suvatee(Tipp a, Tipp b){ ///////////////// GTE_2-1  
	// Antud: selle graafi tipud a ja b
	// Tulemus: tagastatakse tipust a tippu b kulgeva tee info (TeeInfo isendina)
		lbida_sgavuti(a);
		return new TeeInfo(this, b); 
	}//otsida_suvatee
	
	public  void otsida_kik_teed(Tipp t, Tipp b, Vector<TeeInfo> teed){ // GTE_2-2
	// Antud: selle graafi tipud t ja b (sihttipp) 
	//        ning vektor 'teed' leitavate teede lhtetipp..b salvestamiseks;
	//        graafi g tippudele on juba lisatud vlju "eellane", 
	//        seejuures tagasitee tipust t mda eellasi viib (eellaseta) lhtetipuni          
	// Tulemus: g tippudele on lisatud vlju "eellane"; 
	//          graaf g lbitud sgavuti (eellasi seades) alates tipust t;
	//          kui jutud (siht)tippu b, siis vektorisse 'teed' salvestatakse
	//          klassi TeeInfo isendina tee  
	//          tagurpidi <b, b.eellane, ..., eellaseta tipp> koos kogupikkusega
		t.seadaVli("kinni", ""); // tunnuseks, et tipp t asub parajasti otsitaval teel
		if (t == b) // oleme sihil (jrjekordselt)
			teed.add(new TeeInfo(this, b));
		else
			for (Tipp v : naabrid(t)) // jtkata naabritest rekursiivselt 
				if (v.vli("kinni") == null){ // kui naaber v ei asu parajasti otsitaval teel
					v.seadaVli("eellane", "" + (indeks(t)+1)); // v vljale "eellane" tipu t nr
					otsida_kik_teed(v, b, teed);
				}			
// ...........................
	}//otsida_kik_teed
	
	/////////////////////////////////// DIJKSTRA:
	 public void lbida_Dijkstra(Tipp a){ // (GTE_2-3)
	// [pik, lk 100]
	// Antud: lhtetipp a selles graafis,
	//           millest arvestada teiste tippude kaugusi;
	//           igal selle graafi kaarel (v, w) on pikkus c(v, w) = kaar.nimi >= 0;
	//        NB! Kui kaare (arvulist) pikkust ei ole, loetakse see =1.0
	// Tulemus:  on salvestatud tipuvljadesse .d ja .eellane
	//               jrgmiselt:
	//               iga tipu v korral on v.d lhima tee a...v pikkus ja
	//               v.eellane on v-le eelnev tipp (tipu number)  sellel teel;
	//               kui tipp v ei ole algustipust saavutatav, siis v.d = +lpmatus
	//               ja vli v.eellane puudub; ka a.eellane puudub
	
        double lpm = Double.MAX_VALUE; // +lpmatus
		for( int i = 0; i < n(); i++ )
              tipp(i).seadaVli("d", ""+lpm); // +lpmatus
    
        a.seadaVli("d", "0"); // lhtetipu kaugus iseendast
		
		Kahendkuhi Q = new Kahendkuhi(false) { // front 
			
			// konkretiseeritud abstraktne meetod: 
			protected double vti (Object kirje){ // siin vtmeks on tipu vli "d"
				return (d((Tipp)kirje));
			};
			
		};
		
        Q.lisadaKirje(a);
		
//		while (Q.n() != 0){ 
		
// ................................

//		}//while
	}//lbida_Dijkstra
	
	static double d(Tipp t){ // Dijkstra ja Bellman_Ford abimeetod
		// Antud: tipp t
		// Tulemus: tagastatakse selle tipu vljal "d" olev arv	
		return  Double.parseDouble(t.vli("d"));

	}
/////////////////////////////////// DIJKSTRA.


/////////////////////////////////// BELLMAN-FORD:
	public boolean lbida_Bellman_Ford(Tipp a){
	// [pik, lk 102-104, joonis 6.10]
	// Antud: lhtetipp a selles graafis, millest alustada;
	//           g igal kaarel (v, w) on pikkus c(v, w) = kaar.nimi;
	//           kaare pikkus vib ka puududa: (v, w).nimi == "",
	//           siis loetakse pikkuseks 1.0
	// Tulemus: tagastatakse false, kui mne tipu kaugus lhtetipust on -lpmatus, 
	//          vastasel korral tagastatakse true ning siis graafis g
	//          iga tipust a saavutatava tipu v korral on v.d lhima tee a...v pikkus ja
	//          v.eellane on v-le eelnev tipp (tipu number)  sellel teel
	//          kui tipp v ei ole algustipust saavutatav, siis v.d = +lpmatus
	//          ja vli v.eellane puudub; ka a.eellane puudub
		parandada_kaugused_Bellman_Ford(a);
		for( int i = 0; i <= m()-1; i++ ){
			Kaar vw = kaar(i);
			Tipp v = vw.algus();
			Tipp w = vw.lpp();
			double uus_kaugus = d(v) + ((vw.mrgend() != "") ? Double.parseDouble(vw.mrgend()) : 1.0);
			if(uus_kaugus < d(w)){
				w.seadaVli("eellane", "" + indeks(v)+ 1);
				w.seadaVli("d", "" + uus_kaugus);
				return false;
			}
		}//for
        return true;
	}//lbida_Bellman_Ford
	
	protected void parandada_kaugused_Bellman_Ford(Tipp a){
	 // [pik, lk 102-104, joonis 6.8]
	 // Antud: lhtetipp a selles graafis, millest alustada;
	 //           selle graafi igal kaarel (v, w) on pikkus c(v, w);
	 //           kaare pikkus vib ka puududa: (v, w).nimi == "",
	 //           siis loetakse pikkuseks 1.0
	 // Tulemus:  on salvestatud tipuvljadesse .d ja .eellane jrgmiselt:
	 //               iga tipu v korral on v.d lhima tee a...v pikkus ja
	 //               v.eellane on v-le eelnev tipp (tipu number)  sellel teel;
	 //               kui tipp v ei ole algustipust saavutatav, siis v.d = +lpmatus
	 //               ja vli v.eellane puudub; ka a.eellane puudub
		double lpm = Double.MAX_VALUE; // +lpmatus
		for( int i = 0; i < n(); i++ )
			tipp(i).seadaVli("d",""+lpm);
        a.seadaVli("d", "0.0");
		for( int i = 1; i < m(); i++ )
			for( int j = 0; j < m(); j++ ){
                Kaar vw = kaar(j);
				Tipp v = vw.algus();
				Tipp w = vw.lpp();
				
				double uus_kaugus = d(v)  + ((vw.mrgend() != "") ? Double.parseDouble(vw.mrgend()) : 1.0);
				if (uus_kaugus < d(w)){
					w.seadaVli("eellane", "" + (indeks(v)+1));
					w.seadaVli("d", "" + uus_kaugus);
				}
			}//for j
	}//parandada_kaugused_Bellman_Ford
/////////////////////////////////// BELLMAN-FORD.



	public static void main(String[] args){
	// TEST saavutatavaid(), lbida_sgavuti(), otsida_kik_teed(), lbida_Dijkstra()
	
		String fNimi; // vaadeldava graafi fail
		//fNimi = "graafPuu.txt";
		
		fNimi = "graafTeed.txt"; // nt 2 .. 12
		//fNimi = "graafTeedSuur.txt"; // nt 17 .. 10 
		//fNimi = "graafTeedSuurEriPikkused.txt"; // nt 1 .. 21
		//fNimi = "gTest14+.txt"; // nt 1 .. 5
		
		Graaf2 g = new Graaf2(Graaf.failist(fNimi));
		Graaf.kuvada(fNimi);
		System.out.println("\nGraaf failist " + fNimi + ".\n");
		
		int nr0 = 2; // lhtetipu nr
		int nr1 = 12; // lpptipu nr
		
		System.out.println("\nSaavutatavaid tipust " + nr0 + ": " + g.saavutatavaid(g.tipp(nr0-1)));
		
		g.eemaldadaTipuvljad();
		Tipp juur = g.onPuu();
		if(juur != null)
			System.out.println("On puu juurega tipus nr " + (g.indeks(juur)+1) +".");
		else
			System.out.println("Ei ole puustruktuuriga." );
		
		
		g.eemaldadaTipuvljad(); 		
		TeeInfo tInf = g.otsida_suvatee(g.tipp(nr0-1), g.tipp(nr1-1)); // otsida ks tee (testib meetodit lbida_sgavuti)
		System.out.println("\nSuvatee " + nr0 + ".." + nr1 +":  \n\t<" + tInf + ">");	
		
		g.eemaldadaTipuvljad(); 
		Vector<TeeInfo> teed = new Vector<TeeInfo>(); 		// koht leitavatele teedele
		g.otsida_kik_teed(g.tipp(nr0-1), g.tipp(nr1-1), teed); 	// otsida kik teed 
		System.out.println("\nLeitud teid " + nr0 + ".." + nr1 +": "  + teed.size());
		for(TeeInfo tInfo : teed) System.out.println("\t<" + tInfo + ">"); // printida leitud teed
		
		g.eemaldadaTipuvljad(); 
		g.lbida_Dijkstra(g.tipp(nr0-1)); // seada (lhimate tagasiteede) vljad "eellane" lhtudes tipust nr0 
		System.out.println("\nDijkstra leitud lhim tee " + nr0 + ".." + nr1 +":  \n\t<" + new TeeInfo(g, g.tipp(nr1-1)) + ">"); 
		
		g.eemaldadaTipuvljad();
		boolean ok = g.lbida_Bellman_Ford(g.tipp(nr0-1));
		if(ok)
			System.out.println("\nBellman-Fordi leitud lhim tee " + nr0 + ".." + nr1 +":  \n\t<" + new TeeInfo(g, g.tipp(nr1-1)) + ">"); 
	
	}//main		
		
		
}//class