/****************************************************************************************************
*							Algoritmid ja andmestruktuurid
*						Arvutipraktikum 2017/2018 sgissemestril
*						
*								TEEDE OTSIMINE LABRINDIS
*						
*									Autor: Jri Kiho  
*							 
*			Labrint on esitatud bitimaatriksina, 0-element on vaba koht; lisaks on antud veel
*                   sisenemiskoht ja vljumiskoht kahe indeksipaarina (rea indeks, veeru indeks). 
*			Astuda (vabalt kohalt) uuele kohale saab maatriksi piires les, alla, vasakule, paremale,
*			tingimusel, et sihtkoht ei ole 1-element.		
*			Probleemiks on leida teid labrindis antud lhtekohast antud sihtkohta.
*
*		  Labrindi maatriks-esituse asemel uuritakse vastavat smmeetrilist graafi, kusjuures 
*		  graafi kaartele saab olla mratud veel ka selle lbimise raskus (ehk pikkus).
*  							 	  		  
*						--- Lahendamine ksurealt (cmd) ---
*			Eeldus: jooksvas kaustas on fail LabrindiUurimine.java (see fail, ANSI), 
*					klassid Labrint, Labrindid, TeeInfo, Graaf2 
*                   ja fail ee_ut_kiho_aa.zip
*			Kompileerimine:
*					Kaustatee>javac -cp .\;ee_ut_kiho_aa.zip LabrindiUurimine.java
*			Kivitamine:
*					Kaustatee>java  -cp .\;ee_ut_kiho_aa.zip LabrindiUurimine
*
*****************************************************************************************************/

import ee.ut.kiho.aa.graaf.*;
import java.util.Vector;
import java.util.Collections; // max vektorist

import java.util.Scanner; 	  // kui IDE 


class LabrindiUurimine{

	public static void main(String[] args){
		
		int nr;
		for(;;){
			nr = Integer.parseInt(peatus("Nitelabrindi number (1 .. " + Labrindid.n + "):"));
			if(nr >= 1 && nr <= Labrindid.n) break;
			System.out.println("Ei ole nidet nr " + nr);
		}
		Labrint L = Labrindid.nide(nr);	
		
		L.printMaatriks();
				
		Graaf2 g = L.graafiks(Labrindid.juhuraskused); 	// true - juhuraskused llidel (g servadel)

		String gLabNimi = "gLab.txt";
		g.faili(gLabNimi);
		Graaf.kuvada(gLabNimi);
		System.out.println("\nLabrint graafina: " + gLabNimi);
		int aNr = L.tipuNr(L.i0, L.j0); // lhtetipu nr graafis
		int bNr = L.tipuNr(L.i1, L.j1); // sihttipu nr graafis
		System.out.println("    lhtetipu number: " + aNr); 
		System.out.println("    sihttipu number:  " + bNr);
		System.out.println((Labrindid.juhuraskused)? "Servadel juhuraskused " : "Servadel raskuseks == 1.0");
peatus("<Enter>");		

		System.out.println("\n------------------------- KS TEE");
		Vector<Integer> tee = new Vector<Integer>();

		g.eemaldadaTipuvljad();
	 
		long t1 = System.nanoTime();
		TeeInfo tInf = g.otsida_suvatee(g.tipp(aNr-1), g.tipp(bNr-1));
		long t2 = System.nanoTime();		
		System.out.println("Leitud: " + tInf.tipud_teel());
		System.out.println("Aeg (millisek): " + ((t2 - t1)/1000000.0));
		System.out.println("Kuvatud: " + "gYksTee.txt");
		Labrint.kuvada_graaf_leitud_teega(g, tInf.tipud_teel(), "gYksTee.txt");
		System.out.println("Tee raskus: " + Math.round(tInf.pikkus()*100)/100);
peatus("<Enter>");

		System.out.println("\n------------------------- KERGEIM TEE, Bellman-Ford");

		g.eemaldadaTipuvljad();
		
		t1 = System.nanoTime();
		g.lbida_Bellman_Ford(g.tipp(aNr-1));
		t2 = System.nanoTime();	
		TeeInfo tInfBF = new TeeInfo(g, g.tipp(bNr-1));
		System.out.println("Leitud: " + tInfBF.tipud_teel());
		System.out.println("Aeg (millisek): " + ((t2 - t1)/1000000.0));
		System.out.println("Kuvatud: " + "gKergeimBellmanFord.txt");
		Labrint.kuvada_graaf_leitud_teega(g, tInfBF.tipud_teel(), "gKergeimBellmanFord.txt");
		System.out.println("Tee raskus: " + Math.round(tInfBF.pikkus()*100)/100);
peatus("<Enter>");

		System.out.println("\n------------------------- KERGEIM TEE, Dijkstra");
 
		g.eemaldadaTipuvljad();
	
		t1 = System.nanoTime();
		g.lbida_Dijkstra(g.tipp(aNr-1));
		t2 = System.nanoTime();
		TeeInfo tInfDij = new TeeInfo(g, g.tipp(bNr-1));
		System.out.println("Leitud: " + tInfDij.tipud_teel());
		System.out.println("Aeg (millisek): " + ((t2 - t1)/1000000.0));
		System.out.println("Kuvatud: " + "gKergeimDijkstra.txt");
		Labrint.kuvada_graaf_leitud_teega(g, tInfDij.tipud_teel(), "gKergeimDijkstra.txt");
		System.out.println("Tee raskus: " + Math.round(tInfDij.pikkus()*100)/100);
peatus("<Enter>");

		System.out.println("\n------------------------- KIK TEED");
		Vector<TeeInfo> tInfod = new  Vector<TeeInfo>(); // leitavad teed
 
		g.eemaldadaTipuvljad();
	 
		t1 = System.nanoTime();
		g.otsida_kik_teed(g.tipp(aNr-1), g.tipp(bNr-1), tInfod);
		t2 = System.nanoTime();	
		System.out.println("Kikvimalike teede arv: " + tInfod.size());
		System.out.println("Aeg (millisek): " + ((t2 - t1)/1000000.0));
		if(tInfod.size() != 0) {
			//	for(TeeInfo tinf : tInfod)
			//		System.out.println(tinf);		
			// listist 'tInfod' leida raskeim (suurima pikkusega) tee:
			TeeInfo tInfmax = 
				Collections.max( tInfod, (tInf1, tInf2) -> (int)(tInf1.pikkus() - tInf2.pikkus()));
				
			System.out.println("Kuvatud: " + "gRaskeimTee.txt");
			Labrint.kuvada_graaf_leitud_teega(g, tInfmax.tipud_teel(), "gRaskeimTee.txt");
			System.out.println("Tee raskus: " + Math.round(tInfmax.pikkus()*100)/100);
		}
		else
		System.out.println("Teid ei leitud.");
		
peatus("\nLpetamiseks: <Enter>");	
peatus("Kui testi lpetada: <Enter>");		
		System.exit(0);

	}//main
	
	static String peatus(String viip){ // konsoolit vastuse ootamine
	// Antud: tekst viip
	// Tulemus: konsoolile vljastatud viip, 
	//          tagastatakse konsoolilt saadud vastus
	
// kui rakendus ksurealt:
//		 return System.console().readLine(viip);
	
//*/ ldine, kui rakendus arenduskeskkonnast (IDE) vi ksurealt:
		System.out.println(viip);
		try{
			return (new Scanner(System.in)).nextLine();
		}
		catch (Exception e)
			{System.exit(0);} // sundkatkestuse (ctrl+c) korral
		return null; // kompil.
//*/		
	}//peatus
	
}//class LabrindiUurimine