/**************************************************************************************************
*								Algoritmid ja andmestruktuurid
*		  
*										LABRINT
*									
*									Autor: Jri Kiho
*		  
*          Labrint on esitatud bitimaatriksina, 0-element on vaba koht; lisaks on antud veel
*                   sisenemiskoht ja vljumiskoht kahe indeksipaarina (rea indeks, veeru indeks).  
*          Astuda (vabalt kohalt) uuele kohale saab maatriksi piires les, alla, vasakule, paremale,
*          tingimusel, et sihtkoht ei ole 1-element.
*          		  
*		  Labrindi maatriks-esituse asemel saab vaadelda vastavat graafi, kusjuures 
*		  graafi kaartele vib olla mratud veel ka selle ligu lbimise raskus (ehk pikkus).
*		  
*		Isendimeetodid:
*		  	void printMaatriks()
*			Graaf graafiks(boolean juhu)
*			int tipuNr(int i, int j){ // abimeetod
*		Klassimeetod:
*			static void kuvada_graaf_leitud_teega(Graaf g0, Vector<Integer> tee, String fNimi)
*											
*			           --- Kitlemine ksurealt (cmd) ---
*	Eeldus: jooksvas kaustas on failid Labrint.java (see fail, ANSI) ja ee_ut_kiho_aa.zip
*		Kompileerimine:
*			Kaustatee>javac -cp .\;ee_ut_kiho_aa.zip Labrint.java
*
**************************************************************************************************/

import ee.ut.kiho.aa.graaf.*;
import java.util.Vector;
import java.util.Collections; // min vektorist
		
class Labrint{ 

		private int[][] L; // 0-1-maatriks
		private int n, m;  // maatriksi L mtmed (veerge, ridu)
		public int i0, j0; // lhtekoha indeksid maatriksis L
		public int i1, j1; // sihtkoha indeksid maatriksis L
		
		Labrint(int[][] L, int i0, int j0, int i1, int j1){ // konstruktor
			this.L = L.clone();
			this.i0 = i0;
			this.j0 = j0;
			this.i1 = i1;
			this.j1 = j1;
			m = this.L.length; 		// ridade arv
			n = this.L[0].length; 	// veergude arv		
		}//konstruktor
		
		void printMaatriks(){
			System .out.println("\nLabrint (" + m + " x " + n + " maatriks): ");
			System.out.print("    ");
			for( int j = 0; j <= n-1; j++ ) System.out.print(" " + j +":");
			System.out.println();
			for( int i = 0; i <= m-1; i++ ){
				System.out.print((i < 10)? " " + i + ":" : i + ":");
				for( int j = 0; j <= n-1; j++ ) System.out.print((j < 10)? "  "+ L[i][j] : "   "+ L[i][j] );
				System.out.println();
			}
			System.out.println("sisenemiskoha indeksid: " + i0 +" " + j0);
			System.out.println("vljumiskoha  indeksid: " + i1 +" " + j1);
		}//printMaatriks
		
		Graaf2 graafiks(boolean juhu){
			// Antud: juhu -- kas servadele juhuraskused?
			// Tulemus: luuakse ja tagastatakse smmeetriline graaf, 
			//			kus tipp vastab maatriksi L elemendile,
			//          serv seob 0-tipu naaber-0-tipuga;
			//          kik servade mrgendid (raskused) on 1.0, kui juhu = false,
			//          serva mrgend (raskus) on juhuarv [1.0;5.0), kui juhu = true
			int[][] a = L.clone();
			Graaf g = new Graaf(); // tulemusgraaf
			int x0 = 0; // algpunkti x
			int y0 = 0; // algpunkti y
			int hor =800/n; // tippude vahed hor
			int vert = 800/m; // tippude vahed vert
			int dx = Math.min(80, Math.min(hor, vert)); // x muut
			int dy = dx; // y muut
			int y = y0;
			// teha tipud (tehtud tipp saab ka a vastavaks elemendiks):
			for( int i = 0; i <= m-1; i++ ){
				int[] rida = a[i];
				//print(rida);
				int x = x0;
				for( int j = 0; j <= n-1; j++ ){
                    int elem = a[i][j];                
                    Tipp t = new Tipp();
                    g.lisada(t);
                    t.seadaMrgend(elem + "");
                    t.seadaKoordinaadid(x, y);              
                    a[i][j] = g.indeks(t); // tehtud tipu  indeks a elemendiks
                    x += dx;
				}//for
				y += dy;
			}//for
			// teha servad:
			for( int i = 0; i <= m-1; i++ ){
				for( int j = 0; j <= n-1; j++ ){
					if (j > 0){
						Tipp t = g.tipp(a[i][j]);
						Tipp t1 = g.tipp(a[i][j-1]);
						if (t.mrgend().equals("0") && t1.mrgend().equals("0")){						
							double raskus = (juhu) ? 1 + Math.random()*(5) : 1.0;
							raskus = Math.round(raskus*10)/10.0;
							Kaar k = new Kaar(t1, t);
							g.lisada(k);
							k.seadaMrgend(""+raskus);
                            // vastandkaar:
							k = new Kaar(t, t1);
							g.lisada(k);
							k.seadaMrgend(""+raskus);
						}
					}
					if (i > 0){
						Tipp t = g.tipp(a[i][j]);
						Tipp t1 = g.tipp(a[i-1][j]);
						if (t.mrgend().equals("0") && t1.mrgend().equals("0")){
							double raskus = (juhu) ? 1 + Math.random()*(5) : 1;
							raskus = Math.round(raskus*10)/10.0;
							Kaar k = new Kaar(t1, t);
							g.lisada(k);
							k.seadaMrgend(""+raskus);
                            // vastandkaar:
							k = new Kaar(t, t1);
							g.lisada(k);
							k.seadaMrgend(""+raskus);
						}               
					}
				}//for
			}//for
			return new Graaf2(g);
		}//graafiks
		
		public int tipuNr(int i, int j){ // abimeetod
			// Antud: maatriksi L elemendi indeksid i ja j
			// Tulemus: tagastatakse sellele elemendile vastava tipu number graafis
			return i*n + j + 1;
		}		
		
	static void kuvada_graaf_leitud_teega(Graaf g0, Vector<Integer> tee, String fNimi){
         // Antud: graaf g0, tee tippude numbrite loetelu listina 'tee'
		 //        ja graafi salvestusfaili nimi fNimi
         // Tulemus: luuakse ja kuvatakse graaf g1, milles on kik g0 tipud,
         //          kaared aga esitavad antud tee;
		 //          antud graaf g1 on vljastatud tabelina faili fNimi
        Graaf g1 = new Graaf(); // tulemus
         // tipud le kanda:
		for( int i = 0; i <= g0.n()-1; i++ )
              g1.lisada(g0.tipp(i));
        // teha kaared:
		for( int i = 0; i <= tee.size()-2; i++ ){
              Tipp t1 = g0.tipp(tee.get(i)-1);
              Tipp t2 = g0.tipp(tee.get(i+1)-1);
              Kaar k = new Kaar(t1, t2);
              k.seadaMrgend((g0.kaar(t1, t2)).mrgend());
              g1.lisada(k);
		}
        g1.faili(fNimi);
		Graaf.kuvada(fNimi);
	}//kuvada_graaf_leitud_teega


}//class Labrint
